package cz.muni.fi.pv181.java;

import java.io.FileNotFoundException;
import java.security.InvalidKeyException;
import java.security.NoSuchProviderException;
import java.util.Date;
import javax.crypto.NoSuchPaddingException;
import org.bouncycastle.openpgp.PGPException;


import java.io.FileOutputStream;
import java.io.IOException;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.security.Security;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.bouncycastle.openpgp.PGPEncryptedData;
import org.bouncycastle.openpgp.PGPPublicKey;
import org.bouncycastle.openpgp.PGPSecretKey;
import org.bouncycastle.openpgp.PGPSignature;

public class GenPGPKey {
    
    public static void main(String[] args) throws InvalidKeyException, NoSuchAlgorithmException, NoSuchProviderException, FileNotFoundException, PGPException, IOException, NoSuchPaddingException {
    
        Security.addProvider(new BouncyCastleProvider());
        KeyPairGenerator    kpg = KeyPairGenerator.getInstance("RSA", "BC");

        kpg.initialize(1024);

        KeyPair                    kp = kpg.generateKeyPair();

        FileOutputStream    out1 = new FileOutputStream("secret.asc");
        FileOutputStream    out2 = new FileOutputStream("pub.asc");

        String id = "Test";
        String passPhrase = "Ahoj";

        PGPSecretKey    secretKey = new PGPSecretKey(
                PGPSignature.DEFAULT_CERTIFICATION, PGPPublicKey.RSA_GENERAL,
                kp.getPublic(), kp.getPrivate(), new Date(), id,
                PGPEncryptedData.CAST5, passPhrase.toCharArray(), null, null,
                new SecureRandom(), "BC");
        secretKey.encode(out1);
        out1.close();

        PGPPublicKey    key = secretKey.getPublicKey();
        key.encode(out2);
        out2.close();

    }
}
