package cz.muni.fi.pv181.java;

import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;
import javax.net.ssl.*;
import java.net.URL;

/**
 * This class opens secure connection using SSLv3 and writes client's certificate.
 * 
 * @author Pavel Piskac
 */
public class SSLSend {

    public SSLSend(String address, int port) {
        try {
            SSLContext sc = SSLContext.getInstance("SSLv3");
            TrustManager[] tma = { new MyX509TrustManager() };
            sc.init(null, tma, null);
            SSLSocketFactory ssf = sc.getSocketFactory();
            HttpsURLConnection.setDefaultSSLSocketFactory(ssf);
            URL url = new URL(address);
            HttpsURLConnection con = (HttpsURLConnection) url.openConnection();
            HttpsURLConnection.setDefaultSSLSocketFactory(ssf);
            con.setHostnameVerifier(new HostnameVerifier() {

                public boolean verify(String hostname, SSLSession session) {
                    // I don't care if the certificate doesn't match host name 
                    return true;
                }
            });

            con.connect();
            
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    public static void main(String[] args) {
        SSLSend sslSend = new SSLSend("https://sepo.army.cz", 443);
    }
    
    static class MyX509TrustManager implements X509TrustManager {
        public X509Certificate[] getAcceptedIssuers() { return null; }

        public void checkClientTrusted(X509Certificate[] certs, String authType) throws CertificateException {
            System.out.println("X509TrustManager.checkClientTrusted(certs["+certs.length+"],"+authType+")");
        }

        public void checkServerTrusted(X509Certificate[] certs, String authType) throws CertificateException {
            System.out.println("----X509TrustManager.checkServerTrusted-----");
            System.out.println("number of certs: "+certs.length+", authType="+authType);
            for(int i=0;i<certs.length;i++) {
                System.out.println("cert["+i+"]="+certs[i].getSubjectDN());
            }
            System.out.println("--------------------------------------------");
        }
    }
}
