package cz.muni.fi.pv181.java;

import java.security.InvalidKeyException;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.Signature;
import java.security.SignatureException;

/**
 *
 * @author pavel
 */
public class SignHash {

    public SignHash() {
    }

    public KeyPair generateKeyPair() {
        KeyPairGenerator kpg = null;
        try {
            kpg = KeyPairGenerator.getInstance("RSA");
        } catch (NoSuchAlgorithmException ex) {
            ex.printStackTrace();
        }
        return kpg.generateKeyPair();
    }

    public byte[] signHash(byte[] hash, PrivateKey priv) {
        if (priv == null) {
            throw new NullPointerException("priv");
        }
        if (hash == null) {
            throw new NullPointerException("hash");
        }

        byte[] sig = null;
        try {

            Signature rsa = Signature.getInstance("SHA1withRSA");
            /* Initializing the object with a private key */
            rsa.initSign(priv);
            /* Update and sign the data */
            rsa.update(hash);
            sig = rsa.sign();

        } catch (SignatureException ex) {
            ex.printStackTrace();
        } catch (InvalidKeyException ex) {
            ex.printStackTrace();
        } catch (NoSuchAlgorithmException ex) {
            ex.printStackTrace();
        }

        return sig;
    }

    public boolean verifySignature(byte[] original, byte[] sig, PublicKey pub) {
        return false;
    }

    public static void main(String[] args) throws NoSuchProviderException {
        SHA1hash hash = new SHA1hash("\\boot.ini");
        SignHash sh = new SignHash();
        KeyPair kp = sh.generateKeyPair();
        byte[] digest = sh.signHash(hash.getHash(), kp.getPrivate());
        StringBuilder hexString = new StringBuilder();
        for (int i = 0; i < digest.length; i++) {
            hexString.append(Integer.toHexString((digest[i] >>> 4) & 0x0F));
            hexString.append(Integer.toHexString(0x0F & digest[i]));
        }
        System.out.println("hash is " + hexString.toString());

        /*if (sh.verifySignature(hash.getHash(), digest, kp.getPublic())) {
            System.out.println("valid");
        } else {
            System.out.println("something is wrong");
        }*/
    }
}
